//          This is the BBR IM Checker, written by Russ Jackson,           		
//	  inspired by the original checker by Gomez, and tested by BBR members.	 	
//	 Send me feedback via an IM at: http://www.dslreports.com/profile/610601 	

// Set this to "true" if you want to see alerts in the console.
var debugMode = "false";

var wdgtVersion = "1.0";

function runSetup()
{
setup();
if(window.widget) 
	{
	widget.onshow = onshow;
	widget.onhide = onhide;
	}
}

// Our domain name, change to dslreports if you prefer
var domain = "dslreports"		

// Builds the URL we use to check for messages
var url = "http://www." + domain + ".com/instantcheck/"; 

// This function is called first, it checks to see if we have a UID set and if
// so then we continue with checking for IMs
function setup()
{

	// Read in the UID from our preference file
    myUID = widget.preferenceForKey("myUID");
	// Make sure it exists and the length is greater than 0 (null)
	if (myUID && myUID.length > 0)
		{
		if(debugMode == "true") {
		alert("we have an ID - it's " + myUID);
		}
		// UID should be numeric
		if(!IsNumeric(myUID) || myUID == 0) {
			if(debugMode == "true") {
			alert("UID is not valid");
			}
			mainText.style.left="50px";
            mainText.style.color="white";
            mainText.innerText="Invalid UID";
        } else {
        // If everything's good to go, let's check for IMs
        	
		if(window.widget)
			{
			checkForIMs();
			}
		}
		} else {
		// Otherwise we don't have a UID
            mainText.style.color="white";
            if(debugMode == "true") {
            alert("We don't have a UID");
            }
			mainText.style.color="white";
            mainText.style.left="25px";
            mainText.innerText="No UID Entered";
            myUID='';
            showPrefs();
		}

}

// This happens when Dashboard is called
function onshow() {
	clearAll();
	checkForIMs();
	if(debugMode == "true") {
	alert("Dashboard is up - here I am");
	}
}
// This happens when Dashboard goes away
function onhide() {
	if(debugMode == "true") {
	alert("Dashboard is gone - there I go");
	}
	clearAll();
}

// Launches the browser and goes to the homepage (used for the logo)
function goToBBR(event)
{
	if (window.widget)
	{
		widget.openURL('http://www.' + domain + '.com');
	}
}

// Launches the browser and goes to the homepage (used for the logo)
function goToIMs(event)
{
	if (window.widget)
	{
		widget.openURL('http://www.' + domain + '.com/instant/');
	}
}



// Resets images and text
function clearAll()
{
	mainText.innerText="";
	flashingIM.style.display="none";
	siteIsDown.style.display="none";
}
// This function actually makes the http connection to dslr, and is called once
// we've checked for a valid UID
function checkForIMs(event)
{
	// Initialize a random string
	// We do this to make sure our URL is unique and ensure our request is fresh
	// Thanks to Matt Drance for the solution
	// We could make it really random using uuidgen
	// randomString = widget.system('/usr/bin/uuidgen', null).outputString;
	// but for now we'll just generate it based on a time stamp
	randomString = (new Date).getTime();
	if(debugMode == "true") {
	alert("Generating random string");
	}
	// Set up our URL
	dslrURL = url + myUID + "?foo=" + randomString;
	mainText.style.left="50px";
	mainText.style.color="white";
	mainText.innerText="Checking...";
	if(debugMode == "true") {
	alert(mainText.innerText);
	}
	dslrReq = new XMLHttpRequest();
	dslrReq.onreadystatechange = processReqChange;
	dslrReq.open("GET", dslrURL, true);
	if(debugMode == "true") {
	alert('Connecting to ' + dslrURL);
	}
	dslrReq.send();
}

// This function happens when the state of the http request changes
function processReqChange() {
		if(debugMode == "true") {
		alert('http readyState is ' + dslrReq.readyState);
		}
    // only if dslrReq shows "loaded"
    if (dslrReq.readyState == 4) {
		if(debugMode == "true") {
		alert('readyState is complete');
		}

        // only if "OK"
    	if(debugMode == "true") {
    	alert('http status is ' + dslrReq.status);
		alert('returned string is ' + dslrReq.responseText);
		}
    	if (dslrReq.status == 200) {
        		if(debugMode == "true") {
				alert('Checking for new messages');
				}
        		dslrOutput = dslrReq.responseText 
				// Check to see if we have a message or not:
				// If "imsg.gif" exists in the returned string,
				// then we have a message waiting
				if(dslrOutput.indexOf("imsg.gif") > 0)
				{ 
					// Yep, we have a message
					dslrAnswer = "Message Waiting";
					mainText.style.color="yellow";
    				mainText.style.left="17px";
    				flashingIM.style.display="inline";
					} else if(dslrOutput.indexOf("imsg1.gif") > 0) {
					// No, no message waiting
					dslrAnswer = "No new Messages";
					mainText.style.color="white";
    				mainText.style.left="11px";
					} else {
					// For whatever reason, neither string was found in the response
					mainText.style.color="white";
					mainText.style.left="40px";
					dslrAnswer = "I don't know!";
    				
    		} 
        } else {
       		// Site is down or unreachable for some reason
            mainText.style.color="red";
    		mainText.style.left="25px";
    		siteIsDown.style.display="inline";
            dslrAnswer="Cannot connect";
        }
			// Write the answer out to the main window
       	    mainText.innerText=dslrAnswer;
			if(debugMode == "true") {
			alert(dslrAnswer);
			}
    } 
}

// This is a function to test the UID and make sure it is numeric.
function IsNumeric(passedVal)
{
var ValidChars = "0123456789";
var IsNumber=true;
var Char;
if(passedVal == "")
        {return false;}
        for (i = 0; i < passedVal.length && IsNumber == true; i++)
        {
                Char = passedVal.charAt(i);
                if (ValidChars.indexOf(Char) == -1)
                {
                IsNumber = false;
                }
                }
        return IsNumber;

}

// These functions handle the prefs and the flip 
// Most of it came from the "Goodbye World" sample widget

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	version.innerText = wdgtVersion;
	if(myUID != "undefined")
	{
	document.getElementById('myUID').value = myUID;
	} else {
	myUID = "";
	}
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	myUID = document.getElementById('myUID').value;
	if(debugMode == "true") {
	alert("Setting UID to " + myUID);
	}
	widget.setPreferenceForKey(myUID, "myUID");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front

	clearAll();
	setup();
	
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
	}


}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}